	cpu 286
	org 100h

%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
	mov	al,21h
	call	get_int
	mov	ax,2521h
	mov	dx,Int21hook
	int	21h			;hook int21 to return after decompression
	push	cs
	pop	es
	mov	bx,params
	mov	dx,ExeName
	mov	ax,4B00h
	int	21h			;launch exe
ReturnHere:
	lds	dx,[cs:old_int]
	mov	ax,2521h
	int	21h
	push	cs
	pop	ds
	mov	ax,[seg20]
	add	ax,15b8h-1620h
	mov	[seg19],ax
	add	ax,64cfh-15b8h
	mov	[seg76],ax
	add	ax,66d6h-64cfh
	mov	[dseg],ax
	cli
	mov	ds,ax
	mov	ss,ax
	mov	sp,0ad00h
	mov	bp,15E0h
	push	cs
	call	seg20call			;copy sound.rom
	mov	bp,0FE1h
	push	cs
	call	seg20call			;some setup
	push	ax
	mov	bp,162eh
	push	cs
	call	seg20call			;init sound driver
	pop	ax
	push	cs
	pop	ds
	mov	al,8
	call	get_int
	mov	dx,NewInt8
	mov	ax,2508h			;add looping check on timer int
	int	21h				;in game it loops until song's buff ends
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
get_int:
	mov	ah,35h
	int	21h
	mov	[old_int],bx
	mov	[old_int+2],es
	ret
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
Int21hook:
	cmp	ah,30h
	jnz	.old
	pop	ax
	cmp	ax,28E0h
	jnz	Crash			;check if correct version of game file
	pop	w [cs:seg20]
	push	cs
	push	ReturnHere
	iret
.old:
	jmp	far [cs:old_int]
;
NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	xor	bx,bx
	mov	ds,[cs:seg76]
	mov	dx,502h
	mov	cx,-1
	mov	ah,3Fh
	int	21h
	jc	Crash
	push	ds
	push	502h
	mov	bp,166Eh
	push	cs
	call	seg20call		;setup default timbres
	pop	ax
	pop	ds
	push	400h
	push	ds
	push	502h+0Ch
	push	ds
	push	502h
	mov	bp,161ah
	push	cs
	call	seg20call		;start playing
	add	sp,5*2
	mov	b [cs:playing],1
	jmp	@@exitint
@@stop:
	mov	b [playing],0
	mov	bp,160bh	
	push	cs
	call	seg20call
	ret
seg20call:
	mov	ds,[cs:dseg]
	push	w [cs:seg20]
	push	bp
	retf
NewInt8:
	cli
	cmp	b [cs:playing],1
	jnz	@@bye
	pusha
	push	ds
	push	es
	mov	ds,[cs:dseg]
	call	far [cs:seg19call]
	pop	es
	pop	ds
	popa
@@bye:
	jmp	far [cs:old_int]

ExeName	db 'THIEF.EXE',0
	align 2
seg19call	dw 482h
seg19	dw 0
seg20	dw 0
seg76	dw 0
dseg	dw 0
params	dw 0,0,0,0,0,0,0
old_int	dd 0
playing	db 0
	db	13,10,13,10,"The Bard's Tale III PC98 Driver v1.0 by Mok"
ENDDRIVER:

	end
