	cpu 286
	org 100h
%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
	mov	bx,1000h
	mov	ah,48h
	int	21h
	jc	Crash
	mov	[seg1],ax
	mov	ds,ax
	mov	dx,100h
	mov	cx,-1
	mov	bx,10
	mov	ah,3Fh
	int	21h
	jc	Crash
	mov	sp,-2
	mov	al,0cbh
	mov	[195h],al		;init
	mov	[225h],al		;play
	mov	[58ah],al		;restart

	mov	bp,192h
	call	DRIVER

	cli
	push	cs
	pop	ds
	mov	ax,2508h
	mov	dx,NewInt8
	int	21h
	mov	dx,2
	in	al,dx
	and	al,-2
	out	dx,al
	mov	al,36h
	out	77h,al
	xor	al,al
	out	70h,al
	out	70h,al
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
NewInt8:
	cli
	pusha
	push	ds
	push	es
	mov	bp,53ah
	call	DRIVER
	mov	al,20h
	out	0,al
	pop	es
	pop	ds
	popa
	iret

NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	mov	dx,7E2h
	in	ax,dx
	mov	bp,222h
	call	DRIVER
	jmp	@@exitint
@@stop:
	xor	al,al
	mov	bp,222h
DRIVER:
	mov	[cs:seg1call],bp
	mov	ds,[cs:seg1]
	mov	ds,[cs:seg1]
	call	far [cs:seg1call]
	ret

	align 2
seg1call	dw 0
seg1		dw 0
	db	13,10,13,10,"Tamura Mitsuaki no Mahjong Seminar PC98 Driver v1.0 by Mok"
ENDDRIVER:
	end
